﻿Type=Class
Version=4.5
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private ws As WebSocket 'ignore
	' will hold our page information
	Public page As ABMPage
	' page theme
	Private theme As ABMTheme
	' to access the constants
	Private ABM As ABMaterial 'ignore	
	' name of the page, must be the same as the class name (case sensitive!)
	Public Name As String = "LEDControlPage"
	' name of the app, same as in ABMApplication
	Public AppName As String = "LEDControl"
	
	' your own variables
	Dim buttonon As ABMButton
	Dim buttonoff As ABMButton
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	' build the local structure IMPORTANT!
	BuildPage
End Sub

Private Sub WebSocket_Connected (WebSocket1 As WebSocket)
	Log("Connected")
	ws = WebSocket1	
	If ABMShared.NeedsAuthorization Then
		If ws.Session.GetAttribute2("IsAuthorized", "") = "" Then
			ABMShared.NavigateToPage(ws, "../")
			Return
		End If
	End If
	' connect our page with the websocket	
	page.SetWebSocket(ws)	
	' Prepare the page IMPORTANT!
	page.Prepare	
End Sub

Private Sub WebSocket_Disconnected
	
	Log("Disconnected")
End Sub

Sub Page_ParseEvent(Params As Map) 
	Dim eventName As String = Params.Get("eventname")
	Dim eventParams() As String = Regex.Split(",",Params.Get("eventparams"))
	If SubExists(Me, eventName) Then
		Params.Remove("eventname")
		Params.Remove("eventparams")
		Select Case Params.Size
			Case 0
				CallSub(Me, eventName)
			Case 1
				CallSub2(Me, eventName, Params.Get(eventParams(0)))					
			Case 2
				If Params.get(eventParams(0)) = "abmistable" Then
					Dim PassedTables As List = ABM.ProcessTablesFromTargetName(Params.get(eventParams(1)))
					CallSub2(Me, eventName, PassedTables)
				Else
					CallSub3(Me, eventName, Params.Get(eventParams(0)), Params.Get(eventParams(1)))
				End If
			Case Else
				' cannot be called diretly, to many param
				CallSub2(Me, eventName, Params)				
		End Select
	End If
End Sub

public Sub BuildTheme()
	' start with the base theme defined in ABMShared
	theme.Initialize("pagetheme")
	theme.AddABMTheme(ABMShared.MyTheme)
	
	' add additional themes specific for this page
	
End Sub

public Sub BuildPage()
	' initialize the theme
	BuildTheme
	
	' initialize this page using our theme
	page.InitializeWithTheme(Name, "/ws/" & AppName & "/" & Name, False, theme)
	page.ShowLoader=True
	page.PageHTMLName = "index.html"
	page.PageTitle = ""
	page.PageDescription = ""
	page.PageKeywords = ""
	page.PageSiteMapPriority = ""
	page.PageSiteMapFrequency = ABM.SITEMAP_FREQ_YEARLY
		
	' adding a navigation bar
	
			
	' create the page grid

	' row 1: header
	page.AddRows(1,False, "headertheme").AddCells12(1,"headertheme")
	' row 2 & 3: switches
	page.AddRowsM(2,False,0,0,"").AddCellsOS(3,1,1,1,0,0,0,"")
	' row 4
	page.AddRows(1,False, "").AddCells12(1,"")
	' row 5
	page.AddRowsM(1,False, 0,0, "").AddCellsOS(12,0,0,0,1,0,0,"")

	page.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components

	' create controls

	' Header: Add a label to Row 1, Cell 1
	Dim lbl1 As ABMLabel
	lbl1.Initialize(page, "row1cell1lbl1", "B4J HowTo Raspberry Pi LED Switch",ABM.SIZE_H4, True, "whitefc")
	page.Cell(1,1).AddComponent(lbl1)

	' Add a label to Row 2, Cell 1
	Dim lbl2 As ABMLabel
	lbl2.Initialize(page, "row2cell1lbl1", "Switch", ABM.SIZE_SPAN, False, "blackfc")
	page.Cell(2,1).AddComponent(lbl2)

	buttonon.InitializeRaised(page, "buttonon", "mdi-toggle-radio-button-on", ABM.ICONALIGN_LEFT, "ON", "buttonon")
	page.Cell(2,2).AddComponent(buttonon)

	buttonoff.InitializeRaised(page, "buttonoff", "mdi-toggle-radio-button-off", ABM.ICONALIGN_LEFT, "OFF", "buttonoff")
	buttonoff.Enabled = False
	page.Cell(2,3).AddComponent(buttonoff)

	' add paragraph	
	Dim msg As String =  "Set the Pin Number 3 = physical pin 15 = GPIO22 = GPIO_GEN3 as GpioPinDigitalOutput{BR}(the GPIO_GEN3 indicates Pin 3)"
	page.Cell(4,1).AddComponent(ABMShared.BuildParagraph(page,"par3",msg) )

	' row 5 as test
	page.Cell(5,1).AddComponent(ABMShared.BuildParagraph(page,"par3", "1") )
	page.Cell(5,2).AddComponent(ABMShared.BuildParagraph(page,"par3", "2") )
	page.Cell(5,3).AddComponent(ABMShared.BuildParagraph(page,"par3", "3") )
	page.Cell(5,4).AddComponent(ABMShared.BuildParagraph(page,"par3", "4") )
	page.Cell(5,5).AddComponent(ABMShared.BuildParagraph(page,"par3", "5") )
	page.Cell(5,6).AddComponent(ABMShared.BuildParagraph(page,"par3", "6") )
	page.Cell(5,7).AddComponent(ABMShared.BuildParagraph(page,"par3", "7") )
	page.Cell(5,8).AddComponent(ABMShared.BuildParagraph(page,"par3", "8") )
	page.Cell(5,9).AddComponent(ABMShared.BuildParagraph(page,"par3", "9") )
	page.Cell(5,10).AddComponent(ABMShared.BuildParagraph(page,"par3", "10") )
	page.Cell(5,11).AddComponent(ABMShared.BuildParagraph(page,"par3", "11") )
	page.Cell(5,12).AddComponent(ABMShared.BuildParagraph(page,"par3", "12") )

	ABMShared.BuildFooterFixed(page)
End Sub

' clicked on the navigation bar
Sub Page_NavigationbarClicked(Action As String, Value As String)
	page.SaveNavigationBarPosition
	
End Sub

Sub Page_FileUploaded(FileName As String, success As Boolean)	
	
End Sub

Sub Page_ToastClicked(ToastId As String, Action As String)
		
End Sub

Sub Page_ToastDismissed(ToastId As String)	
	
End Sub

Sub Page_Ready()
	Log("LEDControlPage ready!")
	page.RestoreNavigationBarPosition
End Sub

#Region Buttons
Sub buttonon_Clicked(Target As String)
	Log($"Button ON clicked"$)
   	LEDController.Pin3.State = True
	buttonon.Enabled = False
	buttonoff.Enabled = True
	ws.Flush
	page.ws.Flush
	'page.Refresh
End Sub

Sub buttonoff_Clicked(Target As String)
	Log($"Button OFF clicked"$)
   	LEDController.Pin3.State = False
	buttonon.Enabled = True
	buttonoff.Enabled = False
	page.ws.Flush
	'page.Refresh
End Sub

#End Region
