﻿Type=StaticCode
Version=4.5
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
#Region Notes
' Code Module: LEDController
'
#End Region
Sub Process_Globals
	Public Controller As GpioController
  	Public Pin0 As GpioPinDigitalOutput		' Physical pin 11 = GPIO17 = GPIO_GEN0
  	Public Pin1 As GpioPinDigitalOutput		' Physical pin 12 = GPIO18 = GPIO_GEN1
  	Public Pin2 As GpioPinDigitalOutput		' Physical pin 13 = GPIO27 = GPIO_GEN2
  	Public Pin3 As GpioPinDigitalOutput		' Physical pin 15 = GPIO22 = GPIO_GEN3
  	Public Pin4 As GpioPinDigitalOutput		' Physical pin 16 = GPIO23 = GPIO_GEN4
	'ADD MORE PINS as required
End Sub

' Init the GPIO controller
Public Sub Init_GPIOController As Boolean
	Dim Result As Boolean
	' Set GPIO
  	Try
    	Controller.Initialize
		Result =True
  	Catch
    	Log($"GPIO Controller Initialize Error: ${LastException.Message}"$)
		Result = False
  	End Try
	Return Result
End Sub

' Init a Pin as Digital Output
' Example: Init_GPIOPinDigitalOutput(Pin3, 3, False)
' Set the Pin Number 3 = physical pin 15 = GPIO22 = GPIO_GEN3 as GpioPinDigitalOutput with state false means low = turned off
Public Sub Init_GPIOPinDigitalOutput(Pin As GpioPinDigitalOutput, PinNumber As Int, PinState As Boolean)
  	Try
		Pin.Initialize(PinNumber, PinState) 
  	Catch
    	Log($"GPIO Pin Initialize Error: ${LastException.Message}"$)
    	Return
  	End Try
	
End Sub

' Set the pin state to high (true) or low(false)
Public Sub SetPinState(Pin As GpioPinDigitalOutput, PinState As Boolean)
  	Try
		Pin.State = PinState
  	Catch
    	Log("Controller Initialize Error:" & CRLF & LastException.Message)
    	Return
  	End Try
	
End Sub
